Index: branches/v2_0_0_prep/frameworks/_fwAndami/src/org/gvsig/andami/actioninfo/ActionInfoManager.java
===================================================================
--- branches/v2_0_0_prep/frameworks/_fwAndami/src/org/gvsig/andami/actioninfo/ActionInfoManager.java	(revision 0)
+++ branches/v2_0_0_prep/frameworks/_fwAndami/src/org/gvsig/andami/actioninfo/ActionInfoManager.java	(revision 38564)
@@ -0,0 +1,51 @@
+package org.gvsig.andami.actioninfo;
+
+import java.util.Iterator;
+
+import org.gvsig.andami.plugins.IExtension;
+
+public interface ActionInfoManager {
+
+	/**
+	 * Create a new action and return.
+	 * 
+	 * @param extension, class that execute the action, extends IExtension
+	 * @param name, name of the action
+	 * @param text, text to use to represent the action.
+	 * @param command, command used to execute the action
+	 * @param icon, icon used to represent the action
+	 * @param accelerator, the key which invokes the action
+	 * @param position, position of the action when it is represented in the user interface
+	 * @param tip, tooltip to associate to the action
+	 * @return
+	 */
+    public ActionInfo createAction(Class<? extends IExtension> extension, String name, String text, String command, String icon, String accelerator, long position, String tip);
+    
+    /**
+     * Register the action in the actions of the system, and return the action
+     * that is registered.
+     * 
+     * If an action with the same name is in the system then actions are merged
+     * and the merged action is returned and remain in the system.
+     * 
+     * @param action
+     */
+    public ActionInfo registerAction(ActionInfo action);
+     
+    /**
+     * Retrieve an action by name
+     * 
+     * @param name
+     * @return the action associated to this name
+     */
+    public ActionInfo getAction(String name);
+    
+    /**
+     * Return an iterator over all registered actions.
+     * 
+     * @return iterator over al acctions
+     */
+    public Iterator<ActionInfo> getActions();
+    
+    public ActionInfoStatusCache createActionStatusCache();
+}

Index: branches/v2_0_0_prep/frameworks/_fwAndami/src/org/gvsig/andami/actioninfo/ActionInfo.java
===================================================================
--- branches/v2_0_0_prep/frameworks/_fwAndami/src/org/gvsig/andami/actioninfo/ActionInfo.java	(revision 0)
+++ branches/v2_0_0_prep/frameworks/_fwAndami/src/org/gvsig/andami/actioninfo/ActionInfo.java	(revision 38564)
@@ -0,0 +1,32 @@
+package org.gvsig.andami.actioninfo;
+
+import java.awt.event.ActionListener;
+
+import javax.swing.Action;
+import javax.swing.ImageIcon;
+import javax.swing.KeyStroke;
+
+import org.gvsig.andami.PluginServices;
+import org.gvsig.andami.plugins.IExtension;
+
+public interface ActionInfo extends Action, ActionListener{
+	public void merge(ActionInfo other);
+	public PluginServices getPlugin();
+	public IExtension getExtension();
+	public String getPluginName();
+	public String getExtensionName();
+	public String getName();
+	public String getLabel();
+	public String getCommand();
+	public ImageIcon getIcon();
+	public String getIconName();
+	public String getAccelerator();
+	public KeyStroke getKeyStroke();
+	public String getTooltip();
+	public long getPosition();
+	public boolean isVisible();
+	public boolean isEnabled();
+	public void execute();
+	public void execute(Object[] args);
+	public void execute(Object arg);
+}

Index: branches/v2_0_0_prep/frameworks/_fwAndami/src/org/gvsig/andami/actioninfo/ActionInfoStatusCache.java
===================================================================
--- branches/v2_0_0_prep/frameworks/_fwAndami/src/org/gvsig/andami/actioninfo/ActionInfoStatusCache.java	(revision 0)
+++ branches/v2_0_0_prep/frameworks/_fwAndami/src/org/gvsig/andami/actioninfo/ActionInfoStatusCache.java	(revision 38564)
@@ -0,0 +1,9 @@
+package org.gvsig.andami.actioninfo;
+
+public interface ActionInfoStatusCache {
+	public void clear();
+	
+	public boolean isEnabled(ActionInfo action);
+
+	public boolean isVisible(ActionInfo action);
+}
\ No newline at end of file

Index: branches/v2_0_0_prep/frameworks/_fwAndami/src/org/gvsig/andami/actioninfo/impl/DefaultActionInfoStatusCache.java
===================================================================
--- branches/v2_0_0_prep/frameworks/_fwAndami/src/org/gvsig/andami/actioninfo/impl/DefaultActionInfoStatusCache.java	(revision 0)
+++ branches/v2_0_0_prep/frameworks/_fwAndami/src/org/gvsig/andami/actioninfo/impl/DefaultActionInfoStatusCache.java	(revision 38564)
@@ -0,0 +1,81 @@
+package org.gvsig.andami.actioninfo.impl;
+
+import java.util.HashMap;
+import java.util.Map;
+
+import org.gvsig.andami.actioninfo.ActionInfo;
+import org.gvsig.andami.actioninfo.ActionInfoStatusCache;
+import org.gvsig.andami.plugins.ExtensionHelper;
+import org.gvsig.andami.plugins.IExtension;
+
+public class DefaultActionInfoStatusCache implements ActionInfoStatusCache {
+
+	private class Status {
+		Boolean isEnabled = null;
+		Boolean isVisible = null;
+	}
+	
+	private Map<IExtension,Status> extensions = null;
+	private Map<ActionInfo,Status> actions = null;
+	
+	public DefaultActionInfoStatusCache() {
+		this.clear();
+	}
+
+	public void clear() {
+		extensions = new HashMap<IExtension, Status>();
+		actions = new HashMap<ActionInfo, Status>();
+	}
+	
+
+	public boolean isEnabled(ActionInfo action) {
+		Status status; 
+		IExtension extension = action.getExtension();
+		if( ExtensionHelper.canQueryByAction(extension) ) {
+			status = actions.get(action);
+			if( status == null ) {
+				status = new Status();
+				actions.put(action, status);
+			}
+			if( status.isEnabled == null ) {
+				status.isEnabled = new Boolean( action.isEnabled() );
+			}
+		} else {
+			status = extensions.get(extension);
+			if( status == null ) {
+				status = new Status();
+				extensions.put(extension, status);
+			}
+			if( status.isEnabled == null ) {
+				status.isEnabled = new Boolean( extension.isEnabled() );
+			}
+		}
+		return status.isEnabled.booleanValue();
+	}
+
+	public boolean isVisible(ActionInfo action) {
+		Status status; 
+		IExtension extension = action.getExtension();
+		if( ExtensionHelper.canQueryByAction(extension) ) {
+			status = actions.get(action);
+			if( status == null ) {
+				status = new Status();
+				actions.put(action, status);
+			}
+			if( status.isVisible == null ) {
+				status.isVisible = new Boolean( action.isVisible() );
+			}
+		} else {
+			status = extensions.get(extension);
+			if( status == null ) {
+				status = new Status();
+				extensions.put(extension, status);
+			}
+			if( status.isVisible == null ) {
+				status.isVisible = new Boolean( extension.isVisible() );
+			}
+		}
+		return status.isVisible.booleanValue();
+	}
+
+}

Index: branches/v2_0_0_prep/frameworks/_fwAndami/src/org/gvsig/andami/actioninfo/impl/DefaultActionInfoManager.java
===================================================================
--- branches/v2_0_0_prep/frameworks/_fwAndami/src/org/gvsig/andami/actioninfo/impl/DefaultActionInfoManager.java	(revision 0)
+++ branches/v2_0_0_prep/frameworks/_fwAndami/src/org/gvsig/andami/actioninfo/impl/DefaultActionInfoManager.java	(revision 38564)
@@ -0,0 +1,102 @@
+package org.gvsig.andami.actioninfo.impl;
+
+import java.util.ArrayList;
+import java.util.Collections;
+import java.util.Comparator;
+import java.util.HashMap;
+import java.util.Iterator;
+import java.util.List;
+import java.util.Map;
+
+import org.gvsig.andami.actioninfo.ActionInfo;
+import org.gvsig.andami.actioninfo.ActionInfoManager;
+import org.gvsig.andami.actioninfo.ActionInfoStatusCache;
+import org.gvsig.andami.plugins.IExtension;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+public class DefaultActionInfoManager implements  ActionInfoManager {
+	private static Logger logger = LoggerFactory.getLogger(DefaultActionInfoManager.class);
+	
+	private Map<String, ActionInfo>actions = new HashMap<String, ActionInfo>();
+	private int anonymousCounter = 1;
+	
+    public ActionInfo createAction(Class<? extends IExtension> extension, String name, String text, String command, String icon, String enableText, long position, String tip) {
+    	name = emptyToNull(name);
+    	String actionName = name;
+    	if( actionName==null ){
+    		actionName = String.format("anonymous__%04d",this.anonymousCounter++);
+    	}
+    	ActionInfo action = new DefaultActionInfo(extension, actionName, text, command, icon, enableText, position, tip);
+    	ActionInfo previous = this.getAction(action.getName());
+    	if( previous != null ) {
+    		action.merge(previous);
+    	}
+    	if( name == null  ){
+    		logger.info("createAction: name of action is null/empty, rename to '"+actionName+"' ("+action.toString()+").");
+    	}
+    	if( action.getLabel()==null && action.getIconName()==null ) {
+    		logger.info("createAction(name='"+name+"'): text and icon of action is null");
+    	}
+    	return action;
+    }
+	
+	private String emptyToNull(String s) {
+		if( s==null ) {
+			return null;
+		}
+		return "".equals(s.trim())? null:s;
+	}
+	
+    public ActionInfo registerAction(ActionInfo action) {
+    	if( action == null ) {
+    		// Avisamos en el log de que se intenta registrar una accion null, intentado
+    		// sacar el stack para que se pueda ver quien lo esta haciendo, pero no
+    		// provocamos un error, solo retornamos null.
+			try {
+				throw new IllegalArgumentException();
+			} catch (IllegalArgumentException e) {
+				logger.info("registerAction(null).", e);
+			}
+			return null;
+    	}
+    	ActionInfo previous = this.getAction(action.getName());
+    	if( previous != null ) {
+    		previous.merge(action);
+        	return previous;
+    	} else {
+    		this.actions.put(action.getName(), action);
+        	return action;
+    	}
+    }
+    
+    public ActionInfo getAction(String name) {
+    	if( name == null || "".equals(name) ) {
+			try {
+				throw new IllegalArgumentException();
+			} catch (IllegalArgumentException e) {
+				logger.info("getAction(null/empty) return null.", e);
+				return null;
+			}
+    	}
+    	return this.actions.get(name);
+    }
+    
+    public Iterator<ActionInfo> getActions() {
+    	List<ActionInfo> actions = new ArrayList<ActionInfo>();
+    	actions.addAll(this.actions.values());
+    	Collections.sort(actions, new Comparator<ActionInfo>() {
+    		public int compare(ActionInfo arg0, ActionInfo arg1) {
+    			String s0 = String.format("%s/%012d", arg0.getPluginName(), arg0.getPosition());
+    			String s1 = String.format("%s/%012d", arg1.getPluginName(), arg1.getPosition());
+    			return s0.compareTo(s1);
+    		};
+		});
+    	return actions.iterator();
+    }
+    
+    public ActionInfoStatusCache createActionStatusCache() {
+    	return new DefaultActionInfoStatusCache();
+    }
+
+}

Index: branches/v2_0_0_prep/frameworks/_fwAndami/src/org/gvsig/andami/actioninfo/impl/DefaultActionInfo.java
===================================================================
--- branches/v2_0_0_prep/frameworks/_fwAndami/src/org/gvsig/andami/actioninfo/impl/DefaultActionInfo.java	(revision 0)
+++ branches/v2_0_0_prep/frameworks/_fwAndami/src/org/gvsig/andami/actioninfo/impl/DefaultActionInfo.java	(revision 38564)
@@ -0,0 +1,222 @@
+package org.gvsig.andami.actioninfo.impl;
+
+import java.awt.event.ActionEvent;
+import java.beans.PropertyChangeListener;
+
+import javax.swing.Action;
+import javax.swing.ImageIcon;
+import javax.swing.KeyStroke;
+
+import org.gvsig.andami.PluginServices;
+import org.gvsig.andami.PluginsLocator;
+import org.gvsig.andami.actioninfo.ActionInfo;
+import org.gvsig.andami.plugins.ExclusiveUIExtension;
+import org.gvsig.andami.plugins.ExtensionHelper;
+import org.gvsig.andami.plugins.IExtension;
+import org.gvsig.andami.ui.mdiFrame.KeyMapping;
+import org.gvsig.tools.swing.icontheme.IconTheme;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+public class DefaultActionInfo implements ActionInfo {
+    private static Logger logger = LoggerFactory.getLogger(DefaultActionInfo.class);
+    
+	private Class<? extends IExtension> extensionClass;
+	private IExtension extension;
+	private String name;
+	private String text;
+	private String command;
+	private String iconName;
+	private String accelerator;
+	private long position;
+	private String tip;
+	
+	DefaultActionInfo(Class<? extends IExtension> extension, String name, String text, String command, String icon, String accelerator, long position, String tip) {
+		this.extensionClass = extension;
+		this.name = name;
+		this.text = emptyToNull(text) ;
+		this.command = emptyToNull(command);
+		this.iconName = emptyToNull(icon);
+		this.accelerator = emptyToNull(accelerator);
+		this.position = position; 
+		this.tip = emptyToNull(tip);
+	}
+	
+
+	private String emptyToNull(String s) {
+		if( s==null ) {
+			return null;
+		}
+		return s.trim().length()<0 ? null:s;
+	}
+
+	public void merge(ActionInfo other) {
+		if( this.extensionClass == null ) {
+			this.extensionClass = other.getExtension().getClass() ;
+			this.extension = other.getExtension();
+		}
+		if( this.text == null  ) {
+			this.text = other.getLabel();
+		}
+		if( this.command == null  ) {
+			this.command = other.getCommand();
+		}
+		if( this.iconName == null ) {
+			this.iconName = other.getIconName();
+		}
+		if( this.accelerator == null  ) {
+			this.accelerator = other.getAccelerator();
+		}
+		if( this.position < 1 ) {
+			this.position = other.getPosition();
+		}
+		if( this.tip == null  ) {
+			this.tip = other.getTooltip();
+		}
+		
+	}
+	
+	public PluginServices getPlugin() {
+		PluginServices plugin = PluginsLocator.getManager().getPlugin(this.extensionClass);
+		return plugin;
+	}
+	
+	public String getPluginName() {
+		return this.getPlugin().getPluginDirectory().getName();
+	}
+	
+	public IExtension getExtension() {
+		if( this.extension == null ) {
+			this.extension = PluginsLocator.getManager().getExtension(this.extensionClass);
+		}
+		return this.extension;
+	}
+	
+	public String getExtensionName() {
+		return this.extensionClass.getName();
+	}
+
+	public boolean isVisible() {
+		ExclusiveUIExtension eui = PluginsLocator.getManager().getExclusiveUIExtension();
+        if (eui == null) {
+            return ExtensionHelper.isVisible(this.getExtension(), this.command);
+        }
+        return eui.isVisible(this.getExtension());
+	}
+	
+	public boolean isEnabled() {
+		ExclusiveUIExtension eui = PluginsLocator.getManager().getExclusiveUIExtension();
+        if (eui == null) {
+            return ExtensionHelper.isEnabled(this.getExtension(), this.command);
+        }
+        return eui.isEnabled(this.getExtension());
+	}
+	
+	public void execute() {
+        logger.info("{}.execute('{}')", this.getPluginName()+":"+this.getExtensionName(),  this.getCommand());
+		this.getExtension().execute(this.command);
+	}
+
+	public void execute(Object[] args) {
+        logger.info("{}.execute('{}')", this.getPluginName()+":"+this.getExtensionName(),  this.getCommand());
+        ExtensionHelper.execute(this.getExtension(), this.command, args);
+	}
+
+	public void execute(Object arg) {
+		if( arg instanceof Object[] ) {
+			execute((Object[])arg);
+			return;
+		}
+		execute( new Object[] { arg } );
+	}
+	
+	public void actionPerformed(ActionEvent arg0) {
+		this.execute();
+	}
+	
+	public String getName() {
+		return this.name;
+	}
+
+	public String getLabel() {
+		return this.text;
+	}
+
+	public String getCommand() {
+		return this.command;
+	}
+
+	public String getIconName() {
+		return this.iconName;
+	}
+
+	public ImageIcon getIcon() {
+		IconTheme iconTheme = PluginServices.getIconTheme();
+		return iconTheme.get(this.iconName);
+	}
+	
+	public String getAccelerator() {
+		return this.accelerator;
+	}
+
+	public KeyStroke getKeyStroke() {
+		if( emptyToNull(this.accelerator) == null ) {
+			return null;
+		}
+		return KeyMapping.getKeyStroke(this.accelerator);
+	}
+	
+	public long getPosition() {
+		return this.position;
+	}
+	public String getTooltip() {
+		return this.tip;
+	}
+
+	public void addPropertyChangeListener(PropertyChangeListener arg0) {
+		// not implemented
+	}
+
+	public Object getValue(String name) {
+		if( Action.ACTION_COMMAND_KEY.equalsIgnoreCase(name)) {
+			return this.command;
+		}
+		if( Action.LONG_DESCRIPTION.equalsIgnoreCase(name)) {
+			return this.tip;
+		}
+		if( Action.NAME.equalsIgnoreCase(name)) {
+			return this.name;
+		}
+		if( Action.SMALL_ICON.equalsIgnoreCase(name)) {
+			return this.iconName;
+			//return IconThemeManager.getIconThemeManager().getCurrent().get(this.iconName);
+		}
+		return null;
+	}
+
+	public void putValue(String arg0, Object arg1) {
+		
+	}
+
+	public void removePropertyChangeListener(PropertyChangeListener arg0) {
+		// not implemented
+	}
+
+	public void setEnabled(boolean arg0) {
+		// Do nothing
+	}
+	
+    public String toString() {
+    	StringBuffer buffer = new StringBuffer();
+    	buffer.append("ActionInfo {");
+    	buffer.append("name='").append(this.name).append("', ");
+    	buffer.append("label='").append(this.text).append("', ");
+    	buffer.append("tooltip='").append(this.tip).append("', ");
+    	buffer.append("actionCommand='").append(this.command).append("', ");
+    	buffer.append("position='").append(this.position).append("', ");
+    	buffer.append("icon='").append(this.iconName).append("', ");
+    	buffer.append("extension='").append(this.getExtensionName()).append("', ");
+    	buffer.append("accelerator='").append(this.accelerator).append("' }");
+    	return buffer.toString();
+	}
+}

Index: branches/v2_0_0_prep/frameworks/_fwAndami/src/org/gvsig/andami/actioninfo/impl/test.java
===================================================================
--- branches/v2_0_0_prep/frameworks/_fwAndami/src/org/gvsig/andami/actioninfo/impl/test.java	(revision 0)
+++ branches/v2_0_0_prep/frameworks/_fwAndami/src/org/gvsig/andami/actioninfo/impl/test.java	(revision 38564)
@@ -0,0 +1,23 @@
+package org.gvsig.andami.actioninfo.impl;
+
+import java.text.MessageFormat;
+import java.util.Formatter;
+
+public class test {
+
+	/**
+	 * @param args
+	 */
+	public static void main(String[] args) {
+
+		MessageFormat f = new MessageFormat("{0,number,##########}");
+		Long num = new Long(12);
+		Object[] testArgs = { num};
+		String s = f.format(testArgs);
+		System.out.println(s);
+		
+		s = String.format("%010d", num);
+		System.out.println(s);
+	}
+
+}

Index: branches/v2_0_0_prep/frameworks/_fwAndami/src/org/gvsig/andami/IconThemeHelper.java
===================================================================
--- branches/v2_0_0_prep/frameworks/_fwAndami/src/org/gvsig/andami/IconThemeHelper.java	(revision 0)
+++ branches/v2_0_0_prep/frameworks/_fwAndami/src/org/gvsig/andami/IconThemeHelper.java	(revision 38564)
@@ -0,0 +1,46 @@
+package org.gvsig.andami;
+
+import java.awt.Image;
+
+import javax.swing.ImageIcon;
+
+import org.gvsig.tools.swing.api.ToolsSwingLocator;
+import org.gvsig.tools.swing.icontheme.IconTheme;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+public class IconThemeHelper {
+
+	private static Logger logger = LoggerFactory.getLogger(IconThemeHelper.class);
+	
+	@SuppressWarnings("rawtypes")
+	public static void registerIcon(String group, String name, Object obj) {
+		String resourceName;
+		ClassLoader loader;
+		IconTheme iconTheme = ToolsSwingLocator.getIconThemeManager().getCurrent();
+		if( group == null || group.trim().length()==0 ) {
+			resourceName = "images/"+name+".png";
+		} else {
+			resourceName = "images/"+group+"/"+name+".png";
+		}
+		if( obj instanceof Class ) {
+			loader = ((Class) obj).getClassLoader();
+		} else {
+			loader = obj.getClass().getClassLoader();
+		}
+		PluginServices plugin = PluginServices.getPluginServices(obj);
+		try {
+			iconTheme.registerDefault(plugin.getPluginName(), group, name, null, loader.getResource(resourceName));
+		} catch( Throwable e) {
+			logger.info(e.getMessage());
+		}
+	}
+
+	public static ImageIcon getImageIcon(String iconName) {
+		return PluginServices.getIconTheme().get(iconName);
+	}
+	
+	public static Image getImage(String iconName) {
+		return PluginServices.getIconTheme().get(iconName).getImage();
+	}
+}

Index: branches/v2_0_0_prep/frameworks/_fwAndami/src/org/gvsig/tools/swing/icontheme/IconTheme.java
===================================================================
--- branches/v2_0_0_prep/frameworks/_fwAndami/src/org/gvsig/tools/swing/icontheme/IconTheme.java	(revision 0)
+++ branches/v2_0_0_prep/frameworks/_fwAndami/src/org/gvsig/tools/swing/icontheme/IconTheme.java	(revision 38564)
@@ -0,0 +1,205 @@
+package org.gvsig.tools.swing.icontheme;
+
+import java.awt.Image;
+import java.io.File;
+import java.net.URL;
+import java.util.Iterator;
+
+import javax.swing.ImageIcon;
+
+import org.gvsig.andami.PluginServices;
+
+public interface IconTheme {
+	
+	public static final String NO_ICON_NAME = "-no-icon-";
+
+	interface Icon extends Comparable<Icon> {
+		public String getName();
+		public String getGroup() ;
+		public ImageIcon getImageIcon();
+		public Image getImage();
+		public Object getResource() ;
+		public URL getURL() ;
+		public String getLabel();
+		public String getProviderName();
+	}
+
+	/**
+	 * Load all icons from the IconTheme
+	 */
+	public void load(Object resource) throws IllegalArgumentException;
+	
+
+	public void setDefault(IconTheme def);
+
+	public IconTheme getDefault();
+
+	/**
+	 * Returns <code>true</code> if the icon theme contains a mapping for the
+	 * specified iconName.
+	 *
+	 * @param iconName The key to check if it has been registered in this
+	 * IconTheme
+	 *
+	 * @return <code>true</code> if this IconTheme contains
+	 * <code>iconName</code>, <code>false</code> otherwise.
+	 */
+	public boolean exists(String name);
+
+	/**
+	 * Gets the ImageIcon associated with the provided name, if the name
+	 * is present in the theme. If the icon not exists try to return
+	 * a icon with name "no-icon" or returns <code>null</code> if 
+	 * this not exists.
+	 *
+	 * @param name
+	 * 			The name whose associated icon is to be retrieved
+	 *
+	 * @return
+	 * 			The icon associated with the provided name
+	 */
+	public ImageIcon get(String iconName);
+	
+	/**
+	 * Return the ThemeIcon associated with the name.
+	 *  
+	 * @param name of the icon
+	 * @return the IconTheme requiered
+	 */
+	public Icon getThemeIcon(String name);
+
+	/**
+	 * Gets the theme name of the theme
+	 * @return theme name
+	 */
+	public String getName();
+
+	/**
+	 * Sets the theme name of the theme
+	 *
+	 * @param themeName
+	 */
+	public void setName(String themeName);
+
+	public String getID();
+
+	public void setID(String id);
+
+	/**
+	 * Gets the theme description.
+	 *
+	 * @return The description of this theme.
+	 */
+	public String getDescription();
+
+	/**
+	 * Sets the theme description. It should be a short description
+	 * (around 20-30 words), including the highlights of the theme,
+	 * the author and maybe its email address or a link the the theme's
+	 * homepage.
+	 *
+	 * @param description
+	 */
+	public void setDescription(String description);
+
+	/**
+	 * Return an iterator over the names of the icons in the theme.
+	 * 
+	 * @return iterator of names of icons
+	 */
+	public Iterator<String> iterator();
+
+	/**
+	 * Return an iterator over the ThemIcon in the theme.
+	 *  
+	 * @return iterator of ThemeIcon
+	 */
+	public Iterator<Icon> getThemeIcons();
+
+	
+	/**
+	 * Return the icon used as icon by default when the requested icon 
+	 * not exists.
+	 * 
+	 * @return the default icon to use.
+	 */
+	public ImageIcon getDefaultIcon();
+	
+	/**
+	 * Set the default icon to use when the requestd icon not exists.
+	 * 
+	 * @param icon
+	 */
+	public void setDefaultIcon(ImageIcon icon);
+
+	public void setDefaultIcon(URL resource);
+
+	public void setDefaultIcon(String name);
+
+	/**
+	 * Register a icon in the theme.
+	 * The parameter icon can be null if the resource is specified.
+	 * The parameter resource can be null if the icon is specified. 
+	 * 
+	 * Plugin and group can be null.
+	 *  
+	 * @param provider name of the icon
+	 * @param group name for the icon.
+	 * @param name of icon
+	 * @param icon, can be nulll if the resource is specified. 
+	 * @param resource, resource of the icon, usualy and url to the icon.
+	 * 
+	 * @throws IllegalArgumentException if name is null/empty or icon/resource are null
+	 */
+	public void registerDefault(String provider, String group, String name, ImageIcon icon, URL resource) throws IllegalArgumentException;
+
+	/**
+	 * Register a icon in the theme.
+	 * The parameter icon can be null if the resource is specified.
+	 * The parameter resource can be null if the icon is specified. 
+	 * 
+	 * Plugin and group can be null.
+	 * 
+	 * @param provider name of the icon
+	 * @param group name for the icon.
+	 * @param name of icon
+	 * @param icon, can be nulll if the resource is specified. 
+	 * @param resource, resource of the icon, usualy and url to the icon.
+	 * 
+	 * @throws IllegalArgumentException if name is null/empty or icon/resource are null
+	 */
+	public void register(String provider, String group, String name, ImageIcon icon, URL resource) throws IllegalArgumentException;
+
+	public void export(File folder);
+	
+	/**
+	 * @deprecated use {@link #getDefaultIcon()} 
+	 * @return
+	 */
+	public ImageIcon getNoIcon();
+	
+	/**
+	 * @deprecated use {@link #get(String)} instead
+	 */
+	public ImageIcon get(String iconName, ClassLoader loader);
+
+	/**
+	 * @deprecated use {@link #registerDefault(PluginServices, String, String, ImageIcon, Object)}
+	 */
+	public void registerDefault(String iconName, ImageIcon image);
+
+	/**
+	 * @deprecated use {@link #registerDefault(PluginServices, String, String, ImageIcon, Object)}
+	 */
+	public void registerDefault(String iconName, Object resource);
+
+	/**
+	 * @deprecated use {@link #register(PluginServices, String, String, ImageIcon, Object)}
+	 */
+	public void register(String iconName, ImageIcon image);
+
+	/**
+	 * @deprecated use {@link #register(PluginServices, String, String, ImageIcon, Object)}
+	 */
+	public void register(String iconName, Object resource);
+}

